Subject: Re: e1000_down and tx_timeout worker race cleaning the transmit buffers

From: "Michael Chan" <[email-masked]>
Date: Fri, 21 Apr 2006 12:00:31 -0700

On Fri, 2006-04-21 at 16:01 -0400, Andy Gospodarek wrote:

> I just hate to see extra resources used to solve problems that good
> coding can solve (not that my suggestion is necessarily a 'good' one),
> so I was trying to think of a way to resolve this without explicitly
> adding another workqueue.

If you don't want to add another workqueue, then look at tg3, bnx2, and
one of the smc drivers on how to effectively wait for the driver's
workqueue task to finish without deadlocking with linkwatch_event.